/**********************************************************************
Copyright (c) 2009 Andy Jefferson and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
   ...
**********************************************************************/
package org.datanucleus.jpa.criteria;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.Expression;
import javax.persistence.criteria.Predicate;

/**
 * Implementation of JPA2 Criteria "Predicate".
 */
public class PredicateImpl extends ExpressionImpl<Boolean> implements Predicate
{
    protected final List<Predicate> exprs = new ArrayList<Predicate>();

    boolean negated = false;

    BooleanOperator operator = null;

    public PredicateImpl(Class<Boolean> cls)
    {
        super(cls);
        // TODO Auto-generated constructor stub
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.Predicate#getExpressions()
     */
    public List<Expression<Boolean>> getExpressions()
    {
        if (exprs == null)
        {
            return null;
        }
        return new ArrayList<Expression<Boolean>>(exprs);
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.Predicate#getOperator()
     */
    public BooleanOperator getOperator()
    {
        return operator;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.Predicate#isNegated()
     */
    public boolean isNegated()
    {
        return negated;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.Predicate#negate()
     */
    public Predicate negate()
    {
        negated = !negated;
        return this;
    }
}