/**********************************************************************
Copyright (c) 2009 Andy Jefferson and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
   ...
**********************************************************************/
package org.datanucleus.jpa.criteria;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Map;
import java.util.Set;

import javax.persistence.Tuple;
import javax.persistence.criteria.CompoundSelection;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Expression;
import javax.persistence.criteria.Order;
import javax.persistence.criteria.ParameterExpression;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.QueryBuilder;
import javax.persistence.criteria.Selection;
import javax.persistence.criteria.Subquery;

import org.datanucleus.jpa.metamodel.MetamodelImpl;

/**
 * Implementation of JPA2 Criteria "QueryBuilder".
 * Acts as a factory for expressions, and also for the criteria queries themselves.
 */
public class QueryBuilderImpl implements QueryBuilder
{
    MetamodelImpl model;

    public QueryBuilderImpl(MetamodelImpl model)
    {
        this.model = model;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#createQuery()
     */
    public CriteriaQuery<Object> createQuery()
    {
        return new CriteriaQueryImpl<Object>(model, null);
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#createQuery(java.lang.Class)
     */
    public <T> CriteriaQuery<T> createQuery(Class<T> resultCls)
    {
        return new CriteriaQueryImpl<T>(model, resultCls);
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#createTupleQuery()
     */
    public CriteriaQuery<Tuple> createTupleQuery()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#asc(javax.persistence.criteria.Expression)
     */
    public Order asc(Expression<?> expr)
    {
        return new OrderImpl(expr, true);
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#desc(javax.persistence.criteria.Expression)
     */
    public Order desc(Expression<?> expr)
    {
        return new OrderImpl(expr, false);
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#abs(javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> abs(Expression<N> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#avg(javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<Double> avg(Expression<N> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#count(javax.persistence.criteria.Expression)
     */
    public Expression<Long> count(Expression<?> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#countDistinct(javax.persistence.criteria.Expression)
     */
    public Expression<Long> countDistinct(Expression<?> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#max(javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> max(Expression<N> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#min(javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> min(Expression<N> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#sum(javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> sum(Expression<N> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#sum(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> sum(Expression<? extends N> arg0, Expression<? extends N> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#sum(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public <N extends Number> Expression<N> sum(Expression<? extends N> arg0, N arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#sum(java.lang.Number, javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> sum(N arg0, Expression<? extends N> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#all(javax.persistence.criteria.Subquery)
     */
    public <Y> Expression<Y> all(Subquery<Y> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#any(javax.persistence.criteria.Subquery)
     */
    public <Y> Expression<Y> any(Subquery<Y> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#some(javax.persistence.criteria.Subquery)
     */
    public <Y> Expression<Y> some(Subquery<Y> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#exists(javax.persistence.criteria.Subquery)
     */
    public Predicate exists(Subquery<?> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#and(javax.persistence.criteria.Predicate[])
     */
    public Predicate and(Predicate... arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#and(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate and(Expression<Boolean> arg0, Expression<Boolean> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#or(javax.persistence.criteria.Predicate[])
     */
    public Predicate or(Predicate... arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#or(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate or(Expression<Boolean> arg0, Expression<Boolean> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#equal(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate equal(Expression<?> arg0, Expression<?> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#equal(javax.persistence.criteria.Expression, java.lang.Object)
     */
    public Predicate equal(Expression<?> arg0, Object arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#ge(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate ge(Expression<? extends Number> arg0, Expression<? extends Number> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#ge(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public Predicate ge(Expression<? extends Number> arg0, Number arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#greaterThan(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y extends Comparable<Y>> Predicate greaterThan(Expression<? extends Y> arg0, Expression<? extends Y> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#greaterThan(javax.persistence.criteria.Expression, java.lang.Comparable)
     */
    public <Y extends Comparable<Y>> Predicate greaterThan(Expression<? extends Y> arg0, Y arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#greaterThanOrEqualTo(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y extends Comparable<Y>> Predicate greaterThanOrEqualTo(Expression<? extends Y> arg0, Expression<? extends Y> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#greaterThanOrEqualTo(javax.persistence.criteria.Expression, java.lang.Comparable)
     */
    public <Y extends Comparable<Y>> Predicate greaterThanOrEqualTo(Expression<? extends Y> arg0, Y arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#gt(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate gt(Expression<? extends Number> arg0, Expression<? extends Number> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#gt(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public Predicate gt(Expression<? extends Number> arg0, Number arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#le(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate le(Expression<? extends Number> arg0, Expression<? extends Number> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#le(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public Predicate le(Expression<? extends Number> arg0, Number arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lessThan(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y extends Comparable<Y>> Predicate lessThan(Expression<? extends Y> arg0, Expression<? extends Y> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lessThan(javax.persistence.criteria.Expression, java.lang.Comparable)
     */
    public <Y extends Comparable<Y>> Predicate lessThan(Expression<? extends Y> arg0, Y arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lessThanOrEqualTo(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y extends Comparable<Y>> Predicate lessThanOrEqualTo(Expression<? extends Y> arg0, Expression<? extends Y> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lessThanOrEqualTo(javax.persistence.criteria.Expression, java.lang.Comparable)
     */
    public <Y extends Comparable<Y>> Predicate lessThanOrEqualTo(Expression<? extends Y> arg0, Y arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lt(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate lt(Expression<? extends Number> arg0, Expression<? extends Number> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lt(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public Predicate lt(Expression<? extends Number> arg0, Number arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#array(javax.persistence.criteria.Selection<?>[])
     */
    public CompoundSelection<Object[]> array(Selection<?>... arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#between(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y extends Comparable<Y>> Predicate between(Expression<? extends Y> arg0, Expression<? extends Y> arg1,
            Expression<? extends Y> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#between(javax.persistence.criteria.Expression, java.lang.Comparable, java.lang.Comparable)
     */
    public <Y extends Comparable<Y>> Predicate between(Expression<? extends Y> arg0, Y arg1, Y arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#coalesce()
     */
    public <T> Coalesce<T> coalesce()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#coalesce(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y> Expression<Y> coalesce(Expression<? extends Y> arg0, Expression<? extends Y> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#coalesce(javax.persistence.criteria.Expression, java.lang.Object)
     */
    public <Y> Expression<Y> coalesce(Expression<? extends Y> arg0, Y arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#conjunction()
     */
    public Predicate conjunction()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#disjunction()
     */
    public Predicate disjunction()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#construct(java.lang.Class, javax.persistence.criteria.Selection<?>[])
     */
    public <Y> CompoundSelection<Y> construct(Class<Y> arg0, Selection<?>... arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#currentDate()
     */
    public Expression<Date> currentDate()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#currentTime()
     */
    public Expression<Time> currentTime()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#currentTimestamp()
     */
    public Expression<Timestamp> currentTimestamp()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#diff(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> diff(Expression<? extends N> arg0, Expression<? extends N> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#diff(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public <N extends Number> Expression<N> diff(Expression<? extends N> arg0, N arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#diff(java.lang.Number, javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> diff(N arg0, Expression<? extends N> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#function(java.lang.String, java.lang.Class, javax.persistence.criteria.Expression<?>[])
     */
    public <T> Expression<T> function(String arg0, Class<T> arg1, Expression<?>... arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#greatest(javax.persistence.criteria.Expression)
     */
    public <X extends Comparable<X>> Expression<X> greatest(Expression<X> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#in(javax.persistence.criteria.Expression)
     */
    public <T> In<T> in(Expression<? extends T> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isEmpty(javax.persistence.criteria.Expression)
     */
    public <C extends Collection<?>> Predicate isEmpty(Expression<C> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isFalse(javax.persistence.criteria.Expression)
     */
    public Predicate isFalse(Expression<Boolean> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isMember(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <E, C extends Collection<E>> Predicate isMember(Expression<E> arg0, Expression<C> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isMember(java.lang.Object, javax.persistence.criteria.Expression)
     */
    public <E, C extends Collection<E>> Predicate isMember(E arg0, Expression<C> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isNotEmpty(javax.persistence.criteria.Expression)
     */
    public <C extends Collection<?>> Predicate isNotEmpty(Expression<C> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isNotMember(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <E, C extends Collection<E>> Predicate isNotMember(Expression<E> arg0, Expression<C> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isNotMember(java.lang.Object, javax.persistence.criteria.Expression)
     */
    public <E, C extends Collection<E>> Predicate isNotMember(E arg0, Expression<C> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isNotNull(javax.persistence.criteria.Expression)
     */
    public Predicate isNotNull(Expression<?> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isNull(javax.persistence.criteria.Expression)
     */
    public Predicate isNull(Expression<?> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#isTrue(javax.persistence.criteria.Expression)
     */
    public Predicate isTrue(Expression<Boolean> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#keys(java.util.Map)
     */
    public <K, M extends Map<K, ?>> Expression<Set<K>> keys(M arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#least(javax.persistence.criteria.Expression)
     */
    public <X extends Comparable<X>> Expression<X> least(Expression<X> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#length(javax.persistence.criteria.Expression)
     */
    public Expression<Integer> length(Expression<String> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#like(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate like(Expression<String> arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#like(javax.persistence.criteria.Expression, java.lang.String)
     */
    public Predicate like(Expression<String> arg0, String arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#like(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate like(Expression<String> arg0, Expression<String> arg1, Expression<Character> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#like(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, char)
     */
    public Predicate like(Expression<String> arg0, Expression<String> arg1, char arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#like(javax.persistence.criteria.Expression, java.lang.String, javax.persistence.criteria.Expression)
     */
    public Predicate like(Expression<String> arg0, String arg1, Expression<Character> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#like(javax.persistence.criteria.Expression, java.lang.String, char)
     */
    public Predicate like(Expression<String> arg0, String arg1, char arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#literal(java.lang.Object)
     */
    public <T> Expression<T> literal(T arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#locate(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<Integer> locate(Expression<String> arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#locate(javax.persistence.criteria.Expression, java.lang.String)
     */
    public Expression<Integer> locate(Expression<String> arg0, String arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#locate(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<Integer> locate(Expression<String> arg0, Expression<String> arg1, Expression<Integer> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#locate(javax.persistence.criteria.Expression, java.lang.String, int)
     */
    public Expression<Integer> locate(Expression<String> arg0, String arg1, int arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#mod(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<Integer> mod(Expression<Integer> arg0, Expression<Integer> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#mod(javax.persistence.criteria.Expression, java.lang.Integer)
     */
    public Expression<Integer> mod(Expression<Integer> arg0, Integer arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#mod(java.lang.Integer, javax.persistence.criteria.Expression)
     */
    public Expression<Integer> mod(Integer arg0, Expression<Integer> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#neg(javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> neg(Expression<N> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#not(javax.persistence.criteria.Expression)
     */
    public Predicate not(Expression<Boolean> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notEqual(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate notEqual(Expression<?> arg0, Expression<?> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notEqual(javax.persistence.criteria.Expression, java.lang.Object)
     */
    public Predicate notEqual(Expression<?> arg0, Object arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notLike(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate notLike(Expression<String> arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notLike(javax.persistence.criteria.Expression, java.lang.String)
     */
    public Predicate notLike(Expression<String> arg0, String arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notLike(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Predicate notLike(Expression<String> arg0, Expression<String> arg1, Expression<Character> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notLike(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, char)
     */
    public Predicate notLike(Expression<String> arg0, Expression<String> arg1, char arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notLike(javax.persistence.criteria.Expression, java.lang.String, javax.persistence.criteria.Expression)
     */
    public Predicate notLike(Expression<String> arg0, String arg1, Expression<Character> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#notLike(javax.persistence.criteria.Expression, java.lang.String, char)
     */
    public Predicate notLike(Expression<String> arg0, String arg1, char arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#nullLiteral(java.lang.Class)
     */
    public <T> Expression<T> nullLiteral(Class<T> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#nullif(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <Y> Expression<Y> nullif(Expression<Y> arg0, Expression<?> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#nullif(javax.persistence.criteria.Expression, java.lang.Object)
     */
    public <Y> Expression<Y> nullif(Expression<Y> arg0, Y arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#parameter(java.lang.Class)
     */
    public <T> ParameterExpression<T> parameter(Class<T> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#parameter(java.lang.Class, java.lang.String)
     */
    public <T> ParameterExpression<T> parameter(Class<T> arg0, String arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#prod(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> prod(Expression<? extends N> arg0, Expression<? extends N> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#prod(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public <N extends Number> Expression<N> prod(Expression<? extends N> arg0, N arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#prod(java.lang.Number, javax.persistence.criteria.Expression)
     */
    public <N extends Number> Expression<N> prod(N arg0, Expression<? extends N> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#quot(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<Number> quot(Expression<? extends Number> arg0, Expression<? extends Number> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#quot(javax.persistence.criteria.Expression, java.lang.Number)
     */
    public Expression<Number> quot(Expression<? extends Number> arg0, Number arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#quot(java.lang.Number, javax.persistence.criteria.Expression)
     */
    public Expression<Number> quot(Number arg0, Expression<? extends Number> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#selectCase()
     */
    public <R> Case<R> selectCase()
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#selectCase(javax.persistence.criteria.Expression)
     */
    public <C, R> SimpleCase<C, R> selectCase(Expression<? extends C> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#size(javax.persistence.criteria.Expression)
     */
    public <C extends Collection<?>> Expression<Integer> size(Expression<C> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#size(java.util.Collection)
     */
    public <C extends Collection<?>> Expression<Integer> size(C arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#sqrt(javax.persistence.criteria.Expression)
     */
    public Expression<Double> sqrt(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toBigDecimal(javax.persistence.criteria.Expression)
     */
    public Expression<BigDecimal> toBigDecimal(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toBigInteger(javax.persistence.criteria.Expression)
     */
    public Expression<BigInteger> toBigInteger(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toDouble(javax.persistence.criteria.Expression)
     */
    public Expression<Double> toDouble(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toFloat(javax.persistence.criteria.Expression)
     */
    public Expression<Float> toFloat(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toInteger(javax.persistence.criteria.Expression)
     */
    public Expression<Integer> toInteger(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toLong(javax.persistence.criteria.Expression)
     */
    public Expression<Long> toLong(Expression<? extends Number> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#concat(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<String> concat(Expression<String> arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#concat(javax.persistence.criteria.Expression, java.lang.String)
     */
    public Expression<String> concat(Expression<String> arg0, String arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#concat(java.lang.String, javax.persistence.criteria.Expression)
     */
    public Expression<String> concat(String arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#toString(javax.persistence.criteria.Expression)
     */
    public Expression<String> toString(Expression<Character> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#substring(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<String> substring(Expression<String> arg0, Expression<Integer> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#substring(javax.persistence.criteria.Expression, int)
     */
    public Expression<String> substring(Expression<String> arg0, int arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#substring(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<String> substring(Expression<String> arg0, Expression<Integer> arg1, Expression<Integer> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#substring(javax.persistence.criteria.Expression, int, int)
     */
    public Expression<String> substring(Expression<String> arg0, int arg1, int arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#trim(javax.persistence.criteria.Expression)
     */
    public Expression<String> trim(Expression<String> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#trim(javax.persistence.criteria.QueryBuilder.Trimspec, javax.persistence.criteria.Expression)
     */
    public Expression<String> trim(Trimspec arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#trim(javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<String> trim(Expression<Character> arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#trim(char, javax.persistence.criteria.Expression)
     */
    public Expression<String> trim(char arg0, Expression<String> arg1)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#trim(javax.persistence.criteria.QueryBuilder.Trimspec, javax.persistence.criteria.Expression, javax.persistence.criteria.Expression)
     */
    public Expression<String> trim(Trimspec arg0, Expression<Character> arg1, Expression<String> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#trim(javax.persistence.criteria.QueryBuilder.Trimspec, char, javax.persistence.criteria.Expression)
     */
    public Expression<String> trim(Trimspec arg0, char arg1, Expression<String> arg2)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#lower(javax.persistence.criteria.Expression)
     */
    public Expression<String> lower(Expression<String> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#upper(javax.persistence.criteria.Expression)
     */
    public Expression<String> upper(Expression<String> arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#tuple(javax.persistence.criteria.Selection<?>[])
     */
    public CompoundSelection<Tuple> tuple(Selection<?>... arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see javax.persistence.criteria.QueryBuilder#values(java.util.Map)
     */
    public <V, M extends Map<?, V>> Expression<Collection<V>> values(M arg0)
    {
        // TODO Auto-generated method stub
        return null;
    }
}